<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**
*
* @package  VehicleManager
* @copyright 2009 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com); 
* Homepage: http://www.ordasoft.com
* @version: 1.0 Basic $
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

function print_vars($obj) {
    $arr = get_object_vars($obj);
    while (list($prop, $val) = each($arr))
		 if(class_exists($val)) print_vars($val);
		  else echo "\t $prop = $val\n<br />";
}

function print_methods($obj) {
    $arr = get_class_methods(get_class($obj));
    foreach ($arr as $method)   echo "\tfunction $method()\n <br />";
}

if (PHP_VERSION >= 5) {
    // Emulate the old xslt library functions
    function xslt_create() {
        return new XsltProcessor();
    }

    function xslt_process($xsltproc,
                          $xml_arg,
                          $xsl_arg,
                          $xslcontainer = null,
                          $args = null,
                          $params = null) {

        // Create instances of the DomDocument class
        $xml = new DomDocument;
        $xsl = new DomDocument;

        // Load the xml document and the xsl template
        $xml->load($xml_arg);
        $xsl->load($xsl_arg);

        // Load the xsl template
        $xsltproc->importStyleSheet($xsl);

        // Set parameters when defined
        if ($params) {
            foreach ($params as $param => $value) {
                $xsltproc->setParameter("", $param, $value);
            }
        }

        // Start the transformation
        $processed = $xsltproc->transformToXML($xml);

        // Put the result in a file when specified
        if ($xslcontainer) {
            return @file_put_contents($xslcontainer, $processed);
        } else {
            return $processed;
        }

    }

    function xslt_free($xsltproc) {
        unset($xsltproc);
    }
}

class mosVehicleManagerImportExport{
	

	/**
	 * Imports the lines given to this method into the database and writes a
	 * table containing the information of the imported vehicles.
	 * The imported vehicles will be set to [not published] 
	 * Format: #;id;isbn;title;author;language
	 * @param array lines - an array of lines read from the file
	 * @param int catid - the id of the category the vehicles should be added to 
	 */
	function importVehiclesCSV($lines, $catid){
		global $database;
		$retVal= array();
		$i = 0;
	    	foreach ($lines as $line) {
	    		$tmp = array();

			if(trim($line) == "" ) continue;
	    		$line = explode('|', $line);//edit nik  old -->, -1);
				$vehicle = new mosVehicleManager($database);
				$vehicle->vehicleid = trim($line[0]);
				$vehicle->description = $line[1];
				$vehicle->link = $line[2];
                $vehicle->vmodel = $line[3];
                $vehicle->vtype = $line[4];
				        $vehicle->listing_type = $line[5];
                $vehicle->price = $line[6];
                $vehicle->price_type = $line[7];
                $vehicle->vtitle = $line[8];
                $vehicle->vlocation = $line[9];
                $vehicle->vlatitude = $line[10];
                $vehicle->vlongitude = $line[11];
                $vehicle->map_zoom = $line[12];
                $vehicle->year = $line[13];
                $vehicle->vcondition = $line[14];
                $vehicle->mileage = $line[15];
                $vehicle->listing_status = $line[16];
                $vehicle->engine = $line[17];
                $vehicle->transmission = $line[18];
                $vehicle->drive_type = $line[19];
                $vehicle->cylinder = $line[20];
                $vehicle->num_speed = $line[21];
                $vehicle->fuel_type = $line[22];
                $vehicle->city_fuel_mpg = $line[23];
                $vehicle->highway_fuel_mpg = $line[24];
                $vehicle->wheelbase = $line[25];
                $vehicle->wheeltype = $line[26];
                $vehicle->rear_axe_type = $line[27];
                $vehicle->brakes_type = $line[28];
                $vehicle->exterior_color = $line[29];
                $vehicle->doors = $line[30];
                $vehicle->exterior_amenities = $line[31];
                $vehicle->interior_color = $line[32];
                $vehicle->seating = $line[33];
                $vehicle->dashboard_options = $line[34];
                $vehicle->interior_amenities = $line[35];
                $vehicle->safety_options = $line[36];
                $vehicle->w_basic = $line[37];
                $vehicle->w_drivetrain = $line[38];
                $vehicle->w_corrosion = $line[39];
                $vehicle->w_roadside_ass = $line[40];
                
	            $vehicle->catid = $catid;
				    // optimize!!!
			            $tmp[0] = $i;
			            $tmp[1] = trim($line[0]);
//			            $tmp[2] = $line[12];
			            $tmp[2] = $line[8];
                  $tmp[3] = $line[3];
                  $tmp[4] = $vehicle->price;
			            $tmp[5] = $line[6];

				if (!$vehicle->check() || !$vehicle->store()) {
					$tmp[5] =  $vehicle->getError(); 
				} else {
					$tmp[5] =  "OK";
				}
				$vehicle->checkin();
				$vehicle->updateOrder("catid='$vehicle->catid'");
				$retVal[$i] = $tmp;
				$i++;
			}
			return $retVal;
	}

	function getXMLItemValue($item,$item_name) {
	    $vehicle_items = $item->getElementsByTagname( $item_name );
	    $vehicle_item = $vehicle_items->item(0);
	    if(NULL != $vehicle_item) return $vehicle_item->nodeValue ;
		else return "";	
	}

  function findCategory(& $categories, $new_category ) 
  {
    global $database;
  
    foreach( $categories as $category ){
      if($category->old_id == $new_category->old_id ) return  $category;
    }
    $new_parent_id = null;
    if($new_category->old_parent_id != 0 ){
      foreach( $categories as $category ){
        if($category->old_id == $new_category->old_parent_id ){
          $new_parent_id = $category->id;
          break;
        }
      }
    }
    else $new_parent_id = 0;

    //sanity test
    if( $new_parent_id === null) {
      echo "error in import !"; exit;
    }

    $row = new mosCategory($database);
    $row->section='com_vehiclemanager';
    $row->parent_id=$new_parent_id ;
    $row->name=$new_category->name ;
    $row->title=$new_category->title ;
    $row->published=$new_category->published ;

    if (!$row->check()) {
      echo "error in import2 !"; exit;
      exit();
    }
    if (!$row->store()) {
      echo "error in import3 !"; exit;
      exit();
    }

    $row->updateOrder("section='com_vehiclemanager' AND parent_id='$row->parent_id'");

    $new_category->id = $row->id;
    $categories[] = $new_category;

    return  $new_category;
    
  }

//******************   begin add for import XML format   ****************************
	function importVehiclesXML($files_name_pars, $catid) 
	{

    global $database;
    $retVal= array();
    $k = 0;
    $new_categories = array();
    $new_relate_ids = array();

    $dom = new domDocument('1.0','windows-1251');
    $dom->load($files_name_pars);

    if($catid === null){
      $cat_list = $dom->getElementsByTagname('category');
      for ($i = 0; $i < $cat_list->length; $i++){
        $category = $cat_list->item($i);
        $new_category = null;
        $new_category->old_id = mosVehicleManagerImportExport::getXMLItemValue($category,'category_id');
        $new_category->old_parent_id = mosVehicleManagerImportExport::getXMLItemValue($category,'category_parent_id');
        $new_category->name = mosVehicleManagerImportExport::getXMLItemValue($category,'category_name');
        $new_category->title = mosVehicleManagerImportExport::getXMLItemValue($category,'category_title');
        $new_category->published = mosVehicleManagerImportExport::getXMLItemValue($category,'category_published');
        $new_category->params = mosVehicleManagerImportExport::getXMLItemValue($category,'category_type');
        $new_category = mosVehicleManagerImportExport::findCategory($new_categories, $new_category ) ;
      }
    }


		$vehicle_list = $dom->getElementsByTagname('vehicle');
// 		$st = $vehicleid = "";
// 		$begin = $end = $kol = 0;

		for ($i = 0; $i < $vehicle_list->length; $i++) {
		    $vehicle_class = new mosVehicleManager($database);

		    $vehicle = $vehicle_list->item($i);
 
//		    echo $house_item->hasChildNodes() . "<br />";

		    //get VehicleID
		    $vehicle_id = $vehicle_class->vehicleid = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vehicleid'); 
		    //get description
		    $vehicle_description = $vehicle_class->description = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'description');
            //get link
		    $vehicle_class->link = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'link');
		    //get model
        $vehicle_model = $vehicle_class->vmodel = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vmodel');
        //get vehicle type
        $vehicle_class->vtype = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vtype');          
        //get listing_type
		    $vehicle_class->listing_type = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'listing_type');
        //get price
        $vehicle_price = $vehicle_class->price = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'price');
        //get title
        $vehicle_title = $vehicle_class->vtitle = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vtitle');
        //get location
        $vehicle_class->vlocation = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vlocation');
        //get vlatitude
        $vehicle_class->vlatitude = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vlatitude');
        //get vlongitude
        $vehicle_class->vlongitude = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vlongitude');
        //get map_zoom
        $vehicle_class->map_zoom = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'map_zoom');
        //get year
        $vehicle_class->year = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'year');
        //get vcondition
        $vehicle_class->vcondition = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'vcondition');
        //get mileage
        $vehicle_class->mileage = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'mileage');
        //get listing_status
        $vehicle_class->listing_status = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'listing_status');
        //get engine
        $vehicle_class->engine = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'engine');
        //get transmission
        $vehicle_class->transmission = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'transmission');
        //get drive_type
        $vehicle_class->drive_type = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'drive_type');
        //get cylinder
        $vehicle_class->cylinder = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'cylinder');
        //get num_speed
        $vehicle_class->num_speed = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'num_speed');
        //get fuel_type
        $vehicle_class->fuel_type = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'fuel_type');
        //get city_fuel_mpg
        $vehicle_class->city_fuel_mpg = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'city_fuel_mpg');
        //get highway_fuel_mpg
        $vehicle_class->highway_fuel_mpg = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'highway_fuel_mpg');
        //get wheelbase
        $vehicle_class->wheelbase = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'wheelbase');
        //get wheeltype
        $vehicle_class->wheeltype = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'wheeltype');
        //get rear_axe_type
        $vehicle_class->rear_axe_type = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'rear_axe_type');
        //get brakes_type
        $vehicle_class->brakes_type = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'brakes_type');
        //get exterior_color
        $vehicle_class->exterior_color = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'exterior_color');
        //get doors
        $vehicle_class->doors = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'doors');
        //get exterior_amenities
        $vehicle_class->exterior_amenities = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'exterior_amenities');
        //get interior_color
        $vehicle_class->interior_color = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'interior_color');
        //get seating
        $vehicle_class->seating = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'seating');
        //get dashboard_options
        $vehicle_class->dashboard_options = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'dashboard_options');
        //get interior_amenities
        $vehicle_class->interior_amenities = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'interior_amenities');
        //get safety_options
        $vehicle_class->safety_options = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'safety_options');
        //get w_basic
        $vehicle_class->w_basic = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'w_basic');
        //get w_drivetrain
        $vehicle_class->w_drivetrain = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'w_drivetrain');
        //get w_corrosion
        $vehicle_class->w_corrosion = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'w_corrosion');
        //get w_roadside_ass
        $vehicle_class->w_roadside_ass = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'w_roadside_ass');
        //get image_link
        $vehicle_class->image_link = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'image_link');
        //get hits
        $vehicle_class->hits = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'hits');
          //get date
        $vehicle_class->date = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'date');
          //get published
        $vehicle_class->published = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'published');
                                                                                                             
		   
        //get category
        if($catid === null){
          $new_category = null;
          $new_category->old_id = mosVehicleManagerImportExport::getXMLItemValue($vehicle,'catid');
  
          $new_category = mosVehicleManagerImportExport::findCategory($new_categories, $new_category ) ;
  
          //set category
          $vehicle_class->catid = $new_category->id;
        } else {
          $new_category = new mosCategory($database);
          $new_category->Load($catid);
  
          $vehicle_class->catid = $catid;
        }


	            //for output rezult in table
	            $tmp[0] = $i;
	            $tmp[1] = $vehicle_id;
	            $tmp[2] = $vehicle_title;
	            $tmp[3] = $vehicle_model;
	            $tmp[4] = $vehicle_price;

		    if (!$vehicle_class->check() || !$vehicle_class->store()) {    
		       $tmp[5] =  $vehicle_class->getError();
		    } else { $tmp[5] =  "OK"; }

		    $vehicle_class->checkin();
		    $vehicle_class->updateOrder( "catid='$vehicle_class->catid'" );
		    $retVal[$i] = $tmp;

		    //get Reviews
		    if( $tmp[5] =  "OK" && mosVehicleManagerImportExport::getXMLItemValue($vehicle,'reviews') != "" ){
			    $review_list = $vehicle->getElementsByTagname('review'); 
			    for ($j = 0; $j < $review_list->length; $j++) {

			        $review = $review_list->item($j);
    
              //get for review - user_name
              $review_user_name = mosVehicleManagerImportExport::getXMLItemValue($review,'user_name');
              //get for review - user_email
              $review_user_email = mosVehicleManagerImportExport::getXMLItemValue($review,'user_email');
              //get for review - date
              $review_date = mosVehicleManagerImportExport::getXMLItemValue($review,'date');
			        //get for review - rating
			        $review_rating = mosVehicleManagerImportExport::getXMLItemValue($review,'rating');
			        //get for review - title
			        $review_title = mosVehicleManagerImportExport::getXMLItemValue($review,'title');
			        //get for review - comment
			        $review_comment = mosVehicleManagerImportExport::getXMLItemValue($review,'comment');
    
			        //insert data in table jos_realestatemanager_review
			        $database->setQuery("INSERT INTO #__vehiclemanager_review".
				        "\n (fk_vehicleid, user_name,user_email, date, rating, title, comment)".
				        "\n VALUES ".
				        "\n (".$vehicle_class->id.", '".$review_user_name."', '".$review_user_email.
                "', '".$review_date."',".$review_rating.",'".$review_title."', '".$review_comment."');");
			        $database->query();
    
			    } //end for(...) - REVIEW
		    } //end if(...) - REVIEW

        //get rents
        if( $tmp[5] =  "OK" && mosVehicleManagerImportExport::getXMLItemValue($vehicle,'rents') != "" ){
          $rent_list = $vehicle->getElementsByTagname('rent'); 
          for ($j = 0; $j < $rent_list->length; $j++) {

              $rent = $rent_list->item($j);

      				$help = new mosVehicleManager_rent($database);

              //get for rent - rent_from
              $help->rent_from = mosVehicleManagerImportExport::getXMLItemValue($rent,'rent_from');
              //get for rent - rent_until
              $help->rent_until = mosVehicleManagerImportExport::getXMLItemValue($rent,'rent_until');
              //get for rent - rent_return
              $help->rent_return = mosVehicleManagerImportExport::getXMLItemValue($rent,'rent_return');
              //get for rent - user_name
              $help->user_name = mosVehicleManagerImportExport::getXMLItemValue($rent,'user_name');
              //get for rent - user_email
              $help->user_email = mosVehicleManagerImportExport::getXMLItemValue($rent,'user_email');
              //get for rent - user_mailing
              $help->user_mailing = mosVehicleManagerImportExport::getXMLItemValue($rent,'user_mailing');
    
              //insert data in table #__vehiclemanager_rent
				      if (!$help->check() || !$help->store()) {    
				        $tmp[5] =  $help->getError();
				      } else {
      
					      $vehicle_class->fk_rentid = $help->id;
					      if (!$vehicle_class->check() || !$vehicle_class->store()) {    
					        $tmp[5] =  $vehicle_class->getError();
					      } else { $tmp[5] =  "OK"; }
				      }
    
          } //end for(...) - rent
        } //end if(...) - rent

        //get rentrequests
        if( $tmp[5] =  "OK" && mosVehicleManagerImportExport::getXMLItemValue($vehicle,'rentrequests') != "" ){
          $rentrequests_list = $vehicle->getElementsByTagname('rentrequest'); 
          for ($j = 0; $j < $rentrequests_list->length; $j++) {

              $rentrequest = $rentrequests_list->item($j);
    
              //get for rentrequest - rent_from
              $rr_rent_from = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'rent_from');
              //get for rentrequest - rent_until
              $rr_rent_until = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'rent_until');
              //get for rentrequest - rent_return
              $rr_rent_request = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'rent_request');
              //get for rentrequest - user_name
              $rr_user_name = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'user_name');
              //get for rentrequest - user_email
              $rr_user_email = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'user_email');
              //get for rentrequest - user_mailing
              $rr_user_mailing = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'user_mailing');
              //get for rentrequest - status
              $rr_status = mosVehicleManagerImportExport::getXMLItemValue($rentrequest,'status');
    
              //insert data in table jos_vehiclemanager_rent_request
              $database->setQuery("INSERT INTO #__vehiclemanager_rent_request".
                "\n (fk_vehicleid, rent_from,rent_until, rent_request, user_name, user_email, user_mailing,status)".
                "\n VALUES ".
                "\n (".$vehicle_class->id.", '".$rr_rent_from."', '".$rr_rent_until.
                "', '".$rr_rent_request."','".$rr_user_name."','".$rr_user_email."', '".$rr_user_mailing.
                "', '".$rr_status."');");
              $database->query();
    
          } //end for(...) - rentrequest
        } //end if(...) - rentrequest

        //get buyingrequests
        if( $tmp[5] =  "OK" && mosVehicleManagerImportExport::getXMLItemValue($vehicle,'buyingrequests') != "" ){
          $buyingrequests_list = $vehicle->getElementsByTagname('buyingrequest'); 
          for ($j = 0; $j < $buyingrequests_list->length; $j++) {

              $buyingrequest = $buyingrequests_list->item($j);
    
                  //get for $buyingrequest - buying_request
              $br_buying_request = mosVehicleManagerImportExport::getXMLItemValue($buyingrequest,'buying_request');
              //get for $buyingrequest - customer_name
              $br_customer_name = mosVehicleManagerImportExport::getXMLItemValue($buyingrequest,'customer_name');
              //get for $buyingrequest - customer_email
              $br_customer_email = mosVehicleManagerImportExport::getXMLItemValue($buyingrequest,'customer_email');
              //get for $buyingrequest - customer_phone
              $br_customer_phone = mosVehicleManagerImportExport::getXMLItemValue($buyingrequest,'customer_phone');
              //get for $buyingrequest - status
              $br_status = mosVehicleManagerImportExport::getXMLItemValue($buyingrequest,'status');
    
              //insert data in table jos_vehiclemanager_buying_request
              $database->setQuery("INSERT INTO #__vehiclemanager_buying_request".
                "\n (fk_vehicleid, buying_request, customer_name, customer_email, customer_phone,status)".
                "\n VALUES ".
                "\n (".$vehicle_class->id.
                ", '".$br_buying_request."','".$br_customer_name."','".$br_customer_email."', '".$br_customer_phone.
                "', '".$br_status."');");
              $database->query();
    
          } //end for(...) - $buyingrequest
        } //end if(...) - $buyingrequest

        //get images
        if( $tmp[5] =  "OK" && mosVehicleManagerImportExport::getXMLItemValue($vehicle,'images') != "" ){
          $images_list = $vehicle->getElementsByTagname('image'); 
          for ($j = 0; $j < $images_list->length; $j++) {

              $image = $images_list->item($j);
    
                  //get for $image - thumbnail_img
              $image_thumbnail_img = mosVehicleManagerImportExport::getXMLItemValue($image,'thumbnail_img');
              //get for $image - main_img
              $image_main_img = mosVehicleManagerImportExport::getXMLItemValue($image,'main_img');
    
              //insert data in table jos_vehiclemanager_photos
              $database->setQuery("INSERT INTO #__vehiclemanager_photos".
                "\n (fk_vehicleid, thumbnail_img, main_img)".
                "\n VALUES ".
                "\n (".$vehicle_class->id.
                ", '".$image_thumbnail_img."','".$image_main_img."');");
              $database->query();
    
          } //end for(...) - images
        } //end if(...) - images

		}//end for(...) - vehicle
//print_r("2222"); exit;

		return $retVal;
	}
//***************************************************************************************************
//***********************   end add for import XML format   *****************************************
//***************************************************************************************************

	function exportVehiclesXML($vehicles, $all){
		global $mosConfig_live_site, $mosConfig_absolute_path, $vehiclemanager_configuration,$database;
        
// 		$xmlDoc =& new DOMIT_Document();	
// 		$xmlDoc->appendChild($xmlDoc->createProcessingInstruction('xml', "version=\"1.0\" encoding=\"iso-8859-2\"")); 
// 	    
// 		//create and append list element 
// 		$xmlDoc->appendChild($xmlDoc->createElement("vehicles")); 
// 		foreach ($vehicles as $vehicle) {
// 			$xmlDoc->documentElement->appendChild($vehicle->toXML( $xmlDoc, $all)); 
// 		}	
// 		
// 		return $xmlDoc->toNormalizedString();		


    $xmlDoc = new DOMIT_Document(); 
    $strXmlDoc = "";
    //$xmlDoc->appendChild($xmlDoc->createProcessingInstruction('xml', "version=\"1.0\" encoding=\"iso-8859-2\"")); 
    $strXmlDoc .= "<?xml version='1.0' encoding='iso-8859-2'?>\n";
 
    //$istaller_data_dom =  $xmlDoc->createElement("istaller_data");
    $strXmlDoc .= "<vechicles_data>\n";
    if($all){

      //create and append list element
      $categories_dom =   $xmlDoc->createElement("categories");
      $strXmlDoc .= "<categories>\n";

      //$xmlDoc->appendChild($categories_dom);

      $database->setQuery("SELECT name, title,section, id, parent_id, published FROM #__categories ".
                "WHERE section='com_vehiclemanager' order by parent_id ; " );
      $categories = $database->loadObjectList();   

      foreach($categories as $category){
      //add category
        $category_dom =  $xmlDoc->createElement("category");
    
        $category_id =  $xmlDoc->createElement("category_id");
        $category_id->appendChild($xmlDoc->createTextNode($category->id));
        $category_dom->appendChild( $category_id );

        $category_parent_id =  $xmlDoc->createElement("category_parent_id");
        $category_parent_id->appendChild($xmlDoc->createTextNode($category->parent_id));
        $category_dom->appendChild( $category_parent_id );
    
        $category_name =  $xmlDoc->createElement("category_name");
        $category_name->appendChild($xmlDoc->createCDATASection($category->name));
        $category_dom->appendChild( $category_name );
    
        $category_title =  $xmlDoc->createElement("category_title");
        $category_title->appendChild($xmlDoc->createCDATASection($category->title));
        $category_dom->appendChild( $category_title );
    
        $category_section =  $xmlDoc->createElement("category_section");
        $category_section->appendChild($xmlDoc->createTextNode($category->section));
        $category_dom->appendChild( $category_section );
    
        $category_published =  $xmlDoc->createElement("category_published");
        $category_published->appendChild($xmlDoc->createTextNode($category->published));
        $category_dom->appendChild( $category_published );
  
        //$categories_dom->appendChild( $category_dom);
        $strXmlDoc .= $category_dom->toNormalizedString();
      }
      //create and append list element
      //$istaller_data_dom->appendChild($categories_dom);
      $strXmlDoc .= "</categories>\n";
     
     }

    //create and append list element
    $strXmlDoc .= "<vechicles_list>\n";
    foreach ($vehicles as $vehicle) {
//echo "111111"; print_r($vehicle); exit;
      $strXmlDoc .= $vehicle->toXML2($all);
    }
    $strXmlDoc .= "</vechicles_list>\n";

    //$xmlDoc->appendChild($istaller_data_dom);
    $strXmlDoc .= "</vechicles_data>";

    return $strXmlDoc;    

	}
	
	function storeExportFile($data, $type){
      global $mosConfig_live_site, $mosConfig_absolute_path, $vehiclemanager_configuration;
      $fileName = "vehiclemanager_" . date("Ymd_His");
      $fileBase = "/administrator/components/com_vehiclemanager/exports/";
      
      //write the xml file
      $fp = fopen($mosConfig_absolute_path . $fileBase . $fileName . ".xml" , "w", 0); #open for writing
  		
      fwrite($fp, $data); #write all of $data to our opened file
  		fclose($fp); #close the file
  		
  		
  		$InformationArray = array();
  		$InformationArray['xml_file'] = $fileName . '.xml';
  		$InformationArray['log_file'] = $fileName . '.log';
  		$InformationArray['fileBase'] = "file://" . getcwd (). "/components/com_vehiclemanager/exports/";
  		$InformationArray['urlBase'] = $mosConfig_live_site . $fileBase;
  		$InformationArray['out_file'] = $InformationArray['xml_file'];
  		$InformationArray['error'] = null;
  		
  		switch($type){
  			case 'csv': 
	  			$InformationArray['xslt_file'] = 'csv.xsl';
	  			$InformationArray['out_file'] = $fileName . '.csv';
	  			mosVehicleManagerImportExport :: transformPHP4($InformationArray);
  			break;
  			
  			default:
  			break;
  		} 

		return $InformationArray;
	}

	
	function transformPHP4(&$InformationArray){
			// create the XSLT processor^M
			$xh = xslt_create() or die("Could not create XSLT processor");
			
            
			// Process the document
			$result = xslt_process($xh, $InformationArray['fileBase'].$InformationArray['xml_file'],
        $InformationArray['fileBase'].$InformationArray['xslt_file'], 
        $InformationArray['fileBase'].$InformationArray['out_file']);
			
			if (!$result)
      {                     
			    // Something croaked. Show the error
          $InformationArray['error'] = "Cannot process XSLT document: " .
             /*xslt_errno($xh) .*/ " " /*. xslt_error($xh)*/;
			} 
			
			// Destroy the XSLT processor
			xslt_free($xh);

	}
//////////  MY  ///////////////////////////////////////////////


function remove_info()
{
	global $database;
	$database->setQuery('truncate #__vehiclemanager_vehicles');
	$database->query();	
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return $database->stderr();
	}
	$database->setQuery("delete from #__categories where section='com_vehiclemanager'");
	$database->query();	
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return $database->stderr();
	}
  $database->setQuery('truncate #__vehiclemanager_review');
  $database->query(); 
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return $database->stderr();
  }
  $database->setQuery('truncate #__vehiclemanager_photos');
  $database->query(); 
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return $database->stderr();
  }
  $database->setQuery('truncate #__vehiclemanager_rent');
  $database->query(); 
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return $database->stderr();
  }
  $database->setQuery('truncate #__vehiclemanager_rent_request');
  $database->query(); 
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return $database->stderr();
  }
  $database->setQuery('truncate #__vehiclemanager_buying_request');
  $database->query(); 
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return $database->stderr();
  }
	return "";

}

}
?>
