<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**
*
* @package  VehicleManager
* @copyright 2009 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com); 
* Homepage: http://www.ordasoft.com
* @version: 1.0 Basic $
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/


require_once ($mosConfig_absolute_path."/components/com_vehiclemanager/vehiclemanager.class.rent.php");
require_once ($mosConfig_absolute_path."/components/com_vehiclemanager/vehiclemanager.class.review.php");


/**
* Vehicle database table class
*/
class mosVehicleManager extends mosDBTable {

//keys
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $vehicleid=null;
	/** @var int */
	var $catid=null;
	/** @var int */
	var $sid=null;
	/** @var int */
	var $fk_rentid=null;

//Required fields
	/** @var varchar(250) */
	var $description=null;   /* vehicle description. It may be various amenities of the vehicles
	/** @var varchar(250) */
	var $link=null;
	/** @var varchar(45) */
	var $listing_type=null;//(for rent or for sale)	
	/** @var varchar(14) */
	var $price=null;
	/** @var varchar(200) */
	var $vtitle=null;       //beautiful vehicle and views
    /** @var varchar(100) */
    var $vmodel=null;     /*vehicle model
    /** @var varchar(20) */
    var $vtype=null; //sedan, convertible, coupe, crossover, hatchback, pickup, suv, truck, wagon

//Address fields
	/** @var varchar(100) */
	var $vlocation=null;    //address of vehicle
	/** @var varchar(20) */
	var $vlatitude=null;    //latitude of vehicle locatoin
	/** @var varchar(20) */
	var $vlongitude=null;    //longitude
	/** @var tinyint(4) */
	var $map_zoom=1;    //google map zoom

//Recommended fields
	/** @var varchar(4) */
	var $year=null;       //year of   issue
	/** @var varchar(4) */
	var $vcondition=null;    //new or used
	/** @var varchar(20) */
	var $mileage=null;      
	/** @var varchar(200) */
	var $image_link=null;
	/** @var varchar(45) */
	var $listing_status=null;
	/** @var varchar(45) */
	var $price_type=null;    //negotiable or starting
	/** @var varchar(10) */
	var $transmission=null; //manual or automatic
    /** @var varchar(5) */
    var $num_speed=null;    //4Spd, 5Spd, 6Spd, 7Spd, 8Spd 
	/** @var varchar(45) */
	var $interior_color=null; //black, blue, gold, green, maroon, orange, purple, red, silver, gray, brown, white, yellow or many other colors
	/** @var varchar(45) */
    var $exterior_color=null; //many colors
    /** @var varchar(2) */
    var $doors=null; //2, 3, 4, 5

//Optional fields
	/** @var varchar(40) */
	var $engine=null; //2.7L 100 PH 
	/** @var varchar(20) */
    var $fuel_type=null;  //petrol, gas, gasoline, diesel, H, Gas-electric hybrid 
    /** @var varchar(20) */
    var $drive_type=null;  //Fwd, Rwd, Awd, 4wd, 2wd
    /** @var varchar(4) */
    var $cylinder=null;  //4, 5, 6, 8, 10, 12, 16
    /** @var varchar(20) */
    var $wheelbase=null;  //range between forward and back wheel
    /** @var varchar(4) */
    var $seating=null;  //the number of seating places
    /** @var varchar(5) */
    var $city_fuel_mpg=null;  //fuel consumtion in city
    /** @var varchar(5) */
	var $highway_fuel_mpg=null; //	fuel consumtion in highway
    /** @var varchar(30) */
    var $wheeltype=null; //    wheeltype
    /** @var varchar(30) */
    var $rear_axe_type=null; //    rear axe type
    /** @var varchar(30) */
    var $brakes_type=null; //    brakes axe type
    /** @var varchar(250) */
    var $exterior_amenities=null; //    exterior_amenities
    /** @var varchar(250) */
    var $dashboard_options=null; //    dashboard_options
    /** @var varchar(250) */
    var $interior_amenities=null; //    interior_amenities
    /** @var varchar(250) */
    var $safety_options=null; //    safety_options
    /** @var varchar(30) */
    var $w_basic=null; //    basic warranty
    /** @var varchar(30) */
    var $w_drivetrain=null; //    drivetrain warranty
    /** @var varchar(30) */
    var $w_corrosion=null; //    corrosion warranty
    /** @var varchar(30) */
    var $w_roadside_ass=null; //    roadside assistance warranty
    
    
	/** @var boolean */
	var $checked_out=null;
	/** @var time */
	var $checked_out_time=null;
	
	/** @var datetime */
	var $date=null;
	/** @var int */
	var $published=null;
	/** @var int */
	var $hits=null;
	/** @var varchar(200) */
	var $edok_link=null;

	/*/** @var int */
	var $ordering=null;


	/**
	* @param database - A database connector object
	*/
	function mosVehicleManager( &$db ) {
		$this->mosDBTable( '#__vehiclemanager_vehicles', 'id', $db );
	}
	
	// overloaded check function
	function check() {

		global $vehiclemanager_configuration;
			
		// check for existing vehicleid
		
    if(trim($this->vehicleid) == "" ){
      $this->_error = _VEHICLE_MANAGER_ADMIN_INFOTEXT_JS_EDIT_VEHICLEID_CHECK;
      return false;
    }

		$this->_db->setQuery( "SELECT id FROM #__vehiclemanager_vehicles "
			. "\nWHERE vehicleid='$this->vehicleid'");						
		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _VEHICLE_MANAGER_ADMIN_INFOTEXT_JS_EDIT_VEHICLEID;
			return false;
		}

		return true;
	}
	
		
	/**
	* @param string - Target search string
	* not used at the moment
	*/
	function search( $text, $state='', $sectionPrefix='' ) {
		$text = trim( $text );
		/** if ($text == '') { **/
			return array();
		/**}
		
		$this->_db->setQuery( "SELECT date AS created, title,"
		. "\n	author,  '1' AS browsernav, '{$sectionPrefix}Vehicles' AS section"
		. "\nFROM #__rem_vehicles WHERE (title LIKE '%$text%' OR author LIKE '%$text%'"
		. "\n)"
		. "\n ORDER BY created DESC"
		);
		
		return $this->_db->loadObjectList(); **/
	}
	
	function getReviews(){
		$this->_db->setQuery("SELECT id FROM #__vehiclemanager_review \n".
							"WHERE fk_vehicleid='$this->id' ORDER BY id");
		$tmp = $this->_db->loadResultArray();		
		$retVal = array();		
		for($i = 0, $j = count($tmp); $i < $j; $i++ ){
			$help = new mosVehicleManager_review($this->_db);
			$help->load(intval($tmp[$i]));
			$retVal[$i] = $help;
		}		
		return $retVal;	
	}
	
	function getRent(){
		$rent = null;
		if($this->fk_rentid != null && $this->fk_rentid != 0){
			$rent =  new mosVehicleManager_rent($this->_db);
			// load the row from the db table
			$rent->load(intval($this->fk_rentid));
		}
		return $rent;
	}
	
	function getAllRents($exclusion=""){
		$this->_db->setQuery("SELECT id FROM #__vehiclemanager_rent \n".
							"WHERE fk_vehicleid='$this->id' " . $exclusion . " ORDER BY id");
		$tmp = $this->_db->loadResultArray();		
		$retVal = array();		
		for($i = 0, $j = count($tmp); $i < $j; $i++ ){
			$help = new mosVehicleManager_rent($this->_db);
			$help->load(intval($tmp[$i]));
			$retVal[$i] = $help;
		}		
		return $retVal;	
	}

	function getAllRentRequests($exclusion=""){
		$this->_db->setQuery("SELECT id FROM #__vehiclemanager_rent_request \n".
							"WHERE fk_vehicleid='$this->id'" . $exclusion . " ORDER BY id");
		$tmp = $this->_db->loadResultArray();		
		$retVal = array();		
		for($i = 0, $j = count($tmp); $i < $j; $i++ ){
			$help = new mosVehicleManager_rent_request($this->_db);
			$help->load(intval($tmp[$i]));
			$retVal[$i] = $help;
		}		
		return $retVal;	
	}

  function getAllBuyingRequests($exclusion=""){
    $this->_db->setQuery("SELECT id FROM #__vehiclemanager_buying_request \n".
              "WHERE fk_vehicleid='$this->id'" . $exclusion . " ORDER BY id");
    $tmp = $this->_db->loadResultArray();   
    $retVal = array();    
    for($i = 0, $j = count($tmp); $i < $j; $i++ ){
      $help = new mosVehicleManager_buying_request($this->_db);
      $help->load(intval($tmp[$i]));
      $retVal[$i] = $help;
    }   
    return $retVal; 
  }

  function getAllImages($exclusion=""){
    $this->_db->setQuery("SELECT thumbnail_img, main_img FROM #__vehiclemanager_photos \n".
              "WHERE fk_vehicleid='$this->id'" . $exclusion . " ORDER BY id");
    $retVal = $this->_db->loadObjectList();   
    return $retVal; 
  }



	function toXML(& $xmlDoc, $all){
		
		//create and append name element 
		$retVal = & $xmlDoc->createElement("vehicle");
		
    $vehicleid = & $xmlDoc->createElement("vehicleid");
    $vehicleid->appendChild($xmlDoc->createTextNode($this->vehicleid));
    $retVal->appendChild( $vehicleid);
		
		$catid = & $xmlDoc->createElement("catid");
		$catid->appendChild($xmlDoc->createTextNode($this->catid));
		$retVal->appendChild( $catid);
		
		//
		$description = & $xmlDoc->createElement("description");
		$description->appendChild($xmlDoc->createCDATASection($this->description));
		$retVal->appendChild( $description);

		$link = & $xmlDoc->createElement("link");
		$link->appendChild($xmlDoc->createTextNode($this->link));
		$retVal->appendChild( $link);
        		       
    $vmodel = & $xmlDoc->createElement("vmodel");
    $vmodel->appendChild($xmlDoc->createTextNode($this->vmodel));
    $retVal->appendChild( $vmodel);
    
    $vtype = & $xmlDoc->createElement("vtype");
    $vtype->appendChild($xmlDoc->createTextNode($this->vtype));
    $retVal->appendChild( $vtype);
    
    $listing_type = & $xmlDoc->createElement("listing_type");
    $listing_type->appendChild($xmlDoc->createCDATASection($this->listing_type));
    $retVal->appendChild( $listing_type);
    
    $price = & $xmlDoc->createElement("price");
		$price->appendChild($xmlDoc->createTextNode($this->price));
		$retVal->appendChild( $price);
        
    $price_type = & $xmlDoc->createElement("price_type");
    $price_type->appendChild($xmlDoc->createTextNode($this->price_type));
    $retVal->appendChild( $price_type);
                
		$vtitle = & $xmlDoc->createElement("vtitle");
		$vtitle->appendChild($xmlDoc->createCDATASection($this->vtitle));
		$retVal->appendChild( $vtitle);
		
		$vlocation = & $xmlDoc->createElement("vlocation");
		$vlocation->appendChild($xmlDoc->createCDATASection($this->vlocation));
		$retVal->appendChild( $vlocation);

		$vlatitude = & $xmlDoc->createElement("vlatitude");
		$vlatitude->appendChild($xmlDoc->createTextNode($this->vlatitude));
		$retVal->appendChild( $vlatitude);

		$vlongitude = & $xmlDoc->createElement("vlongitude");
		$vlongitude->appendChild($xmlDoc->createTextNode($this->vlongitude));
		$retVal->appendChild( $vlongitude);

		$map_zoom = & $xmlDoc->createElement("map_zoom");
		$map_zoom->appendChild($xmlDoc->createTextNode($this->map_zoom));
		$retVal->appendChild( $map_zoom);
		
//recommended fields
        $year = & $xmlDoc->createElement("year");
        $year->appendChild($xmlDoc->createTextNode($this->year));
        $retVal->appendChild( $year);
        
        $vcondition = & $xmlDoc->createElement("vcondition");
        $vcondition->appendChild($xmlDoc->createTextNode($this->vcondition));
        $retVal->appendChild( $vcondition);
        
        $mileage = & $xmlDoc->createElement("mileage");
        $mileage->appendChild($xmlDoc->createTextNode($this->mileage));
        $retVal->appendChild( $mileage);
        
        $listing_status = & $xmlDoc->createElement("listing_status");
        $listing_status->appendChild($xmlDoc->createTextNode($this->listing_status));
        $retVal->appendChild( $listing_status);
        
//Technical options
        $engine = & $xmlDoc->createElement("engine");
        $engine->appendChild($xmlDoc->createCDATASection($this->engine));
        $retVal->appendChild( $engine);
        
        $transmission = & $xmlDoc->createElement("transmission");
        $transmission->appendChild($xmlDoc->createTextNode($this->transmission));
        $retVal->appendChild( $transmission);
        
        $drive_type = & $xmlDoc->createElement("drive_type");
        $drive_type->appendChild($xmlDoc->createTextNode($this->drive_type));
        $retVal->appendChild( $drive_type);
        
        $cylinder = & $xmlDoc->createElement("cylinder");
        $cylinder->appendChild($xmlDoc->createTextNode($this->cylinder));
        $retVal->appendChild( $cylinder);
        
        $num_speed = & $xmlDoc->createElement("num_speed");
        $num_speed->appendChild($xmlDoc->createTextNode($this->num_speed));
        $retVal->appendChild( $num_speed);
        
        $fuel_type = & $xmlDoc->createElement("fuel_type");
        $fuel_type->appendChild($xmlDoc->createTextNode($this->fuel_type));
        $retVal->appendChild( $fuel_type);
        
        $city_fuel_mpg = & $xmlDoc->createElement("city_fuel_mpg");
        $city_fuel_mpg->appendChild($xmlDoc->createTextNode($this->city_fuel_mpg));
        $retVal->appendChild( $city_fuel_mpg);
        
        $highway_fuel_mpg = & $xmlDoc->createElement("highway_fuel_mpg");
        $highway_fuel_mpg->appendChild($xmlDoc->createTextNode($this->highway_fuel_mpg));
        $retVal->appendChild( $highway_fuel_mpg);
        
        $wheelbase = & $xmlDoc->createElement("wheelbase");
        $wheelbase->appendChild($xmlDoc->createTextNode($this->wheelbase));
        $retVal->appendChild( $wheelbase);
        
        $wheeltype = & $xmlDoc->createElement("wheeltype");
        $wheeltype->appendChild($xmlDoc->createCDATASection($this->wheeltype));
        $retVal->appendChild( $wheeltype);
        
        $rear_axe_type = & $xmlDoc->createElement("rear_axe_type");
        $rear_axe_type->appendChild($xmlDoc->createTextNode($this->rear_axe_type));
        $retVal->appendChild( $rear_axe_type);
        
        $brakes_type = & $xmlDoc->createElement("brakes_type");
        $brakes_type->appendChild($xmlDoc->createTextNode($this->brakes_type));
        $retVal->appendChild( $brakes_type);
        
//Exterior options        
        $exterior_color = & $xmlDoc->createElement("exterior_color");
        $exterior_color->appendChild($xmlDoc->createTextNode($this->exterior_color));
        $retVal->appendChild( $exterior_color);
        
        $doors = & $xmlDoc->createElement("doors");
        $doors->appendChild($xmlDoc->createTextNode($this->doors));
        $retVal->appendChild( $doors);
        
        $exterior_amenities = & $xmlDoc->createElement("exterior_amenities");
        $exterior_amenities->appendChild($xmlDoc->createCDATASection($this->exterior_amenities));
        $retVal->appendChild( $exterior_amenities);
        
//Interior options        
        $interior_color = & $xmlDoc->createElement("interior_color");
        $interior_color->appendChild($xmlDoc->createTextNode($this->interior_color));
        $retVal->appendChild( $interior_color);      
        
        $seating = & $xmlDoc->createElement("seating");
        $seating->appendChild($xmlDoc->createTextNode($this->seating));
        $retVal->appendChild( $seating);     
        
        $dashboard_options = & $xmlDoc->createElement("dashboard_options");
        $dashboard_options->appendChild($xmlDoc->createCDATASection($this->dashboard_options));
        $retVal->appendChild( $dashboard_options);     
        
        $interior_amenities = & $xmlDoc->createElement("interior_amenities");
        $interior_amenities->appendChild($xmlDoc->createCDATASection($this->interior_amenities));
        $retVal->appendChild( $interior_amenities);
        
//Other options
        $safety_options = & $xmlDoc->createElement("safety_options");
        $safety_options->appendChild($xmlDoc->createCDATASection($this->safety_options));
        $retVal->appendChild( $safety_options);
        
        $w_basic = & $xmlDoc->createElement("w_basic");
        $w_basic->appendChild($xmlDoc->createTextNode($this->w_basic));
        $retVal->appendChild( $w_basic);
    
        $w_drivetrain = & $xmlDoc->createElement("w_drivetrain");
        $w_drivetrain->appendChild($xmlDoc->createTextNode($this->w_drivetrain));
        $retVal->appendChild( $w_drivetrain);
        
        $w_corrosion = & $xmlDoc->createElement("w_corrosion");
        $w_corrosion->appendChild($xmlDoc->createTextNode($this->w_corrosion));
        $retVal->appendChild( $w_corrosion);
        
        $w_roadside_ass = & $xmlDoc->createElement("w_roadside_ass");
        $w_roadside_ass->appendChild($xmlDoc->createTextNode($this->w_roadside_ass));
        $retVal->appendChild( $w_roadside_ass);
                   
/*		
		$broker = & $xmlDoc->createElement("broker");
		$broker->appendChild($xmlDoc->createTextNode($this->broker));
		$broker->appendChild( $broker);
*/
		$image_link = & $xmlDoc->createElement("image_link");
		$image_link->appendChild($xmlDoc->createTextNode($this->image_link));
		$retVal->appendChild( $image_link);
       
		$hits = & $xmlDoc->createElement("hits");
		$hits->appendChild($xmlDoc->createTextNode($this->hits));
		$retVal->appendChild( $hits);

		$date = & $xmlDoc->createElement("date");
		$date->appendChild($xmlDoc->createTextNode($this->date));
		$retVal->appendChild( $date);

		$published = & $xmlDoc->createElement("published");
		$published->appendChild($xmlDoc->createTextNode($this->published));
		$retVal->appendChild( $published);
		
		if($all){
			$rents_data = $this->getRent();
			$exclusion = "";
			
			$rents = & $xmlDoc->createElement("rents");
			$rents_data = $this->getAllRents($exclusion);;
			
			foreach($rents_data as $rent_data){
				$rents->appendChild($rent_data->toXML( $xmlDoc));
			}
			$retVal->appendChild( $rents);
		
			$rentrequests = & $xmlDoc->createElement("rentrequests");
			$rentrequests_data = $this->getAllRentRequests($exclusion);
			
			foreach($rentrequests_data as $rentrequest_data){
				$rentrequests->appendChild($rentrequest_data->toXML( $xmlDoc));
			}
			$retVal->appendChild( $rentrequests);

			$buyingrequests = & $xmlDoc->createElement("buyingrequests");
			$buyingrequests_data = $this->getAllBuyingRequests($exclusion);
			foreach($buyingrequests_data as $buyingrequest_data){
				$buyingrequests->appendChild($buyingrequest_data->toXML( $xmlDoc));
			}
			$retVal->appendChild( $buyingrequests);

      $reviews = & $xmlDoc->createElement("reviews");
      $reviews_data = $this->getReviews();
      foreach($reviews_data as $review_data){
        $reviews->appendChild($review_data->toXML( $xmlDoc));
      }
      $retVal->appendChild( $reviews);

      $images = & $xmlDoc->createElement("images");
      $images_data = $this->getAllImages();
      foreach($images_data as $image_data){

        $image = & $xmlDoc->createElement("image");

        $image_thumbnail_img = & $xmlDoc->createElement("thumbnail_img");
        $image_thumbnail_img->appendChild($xmlDoc->createTextNode($image_data->thumbnail_img));
        $image->appendChild( $image_thumbnail_img);

        $image_main_img = & $xmlDoc->createElement("main_img");
        $image_main_img->appendChild($xmlDoc->createTextNode($image_data->main_img));
        $image->appendChild($image_main_img);

        $images->appendChild( $image);
      }
      $retVal->appendChild( $images);
			
		}
		
		return $retVal;
	}

	function toXML2($all){

    $retVal = "<vehicle>\n";

    $retVal .= "<vehicleid>" . $this->vehicleid . "</vehicleid>\n";
    $retVal .= "<catid>" . $this->catid . "</catid>\n";
    $retVal .= "<description><![CDATA[" . $this->description . "]]></description>\n";
    $retVal .= "<link><![CDATA[" . $this->ordering . "]]></link>\n";
    $retVal .= "<vmodel><![CDATA[" . $this->vmodel . "]]></vmodel>\n";
    $retVal .= "<vtype><![CDATA[" . $this->vtype . "]]></vtype>\n";
    $retVal .= "<listing_type><![CDATA[" . $this->listing_type . "]]></listing_type>\n";
    $retVal .= "<price>" . $this->price . "</price>\n";
    $retVal .= "<price_type>" . $this->price_type . "</price_type>\n";
    $retVal .= "<vtitle><![CDATA[" . $this->vtitle . "]]></vtitle>\n";
    $retVal .= "<vlocation><![CDATA[" . $this->vlocation . "]]></vlocation>\n";
    $retVal .= "<vlatitude>" . $this->vlatitude . "</vlatitude>\n";
    $retVal .= "<vlongitude>" . $this->vlongitude . "</vlongitude>\n";
    $retVal .= "<map_zoom>" . $this->map_zoom . "</map_zoom>\n";
    $retVal .= "<year>" . $this->year . "</year>\n";
    $retVal .= "<vcondition><![CDATA[" . $this->vcondition . "]]></vcondition>\n";
    $retVal .= "<mileage>" . $this->mileage . "</mileage>\n";
    $retVal .= "<listing_status><![CDATA[" . $this->listing_status . "]]></listing_status>\n";
    $retVal .= "<engine><![CDATA[" . $this->engine . "]]></engine>\n";
    $retVal .= "<transmission><![CDATA[" . $this->transmission . "]]></transmission>\n";
    $retVal .= "<drive_type><![CDATA[" . $this->drive_type . "]]></drive_type>\n";
    $retVal .= "<cylinder><![CDATA[" . $this->cylinder . "]]></cylinder>\n";
    $retVal .= "<num_speed><![CDATA[" . $this->num_speed . "]]></num_speed>\n";
    $retVal .= "<fuel_type><![CDATA[" . $this->fuel_type . "]]></fuel_type>\n";
    $retVal .= "<city_fuel_mpg><![CDATA[" . $this->city_fuel_mpg . "]]></city_fuel_mpg>\n";
    $retVal .= "<highway_fuel_mpg><![CDATA[" . $this->highway_fuel_mpg . "]]></highway_fuel_mpg>\n";
    $retVal .= "<wheelbase><![CDATA[" . $this->wheelbase . "]]></wheelbase>\n";
    $retVal .= "<wheeltype><![CDATA[" . $this->wheeltype . "]]></wheeltype>\n";
    $retVal .= "<rear_axe_type><![CDATA[" . $this->rear_axe_type . "]]></rear_axe_type>\n";
    $retVal .= "<brakes_type><![CDATA[" . $this->brakes_type . "]]></brakes_type>\n";
    $retVal .= "<exterior_color><![CDATA[" . $this->exterior_color . "]]></exterior_color>\n";
    $retVal .= "<doors>" . $this->doors . "</doors>\n";
    $retVal .= "<exterior_amenities><![CDATA[" . $this->exterior_amenities . "]]></exterior_amenities>\n";
    $retVal .= "<interior_color><![CDATA[" . $this->interior_color . "]]></interior_color>\n";
    $retVal .= "<seating>" . $this->seating . "</seating>\n";
    $retVal .= "<dashboard_options><![CDATA[" . $this->dashboard_options . "]]></dashboard_options>\n";
    $retVal .= "<interior_amenities><![CDATA[" . $this->interior_amenities . "]]></interior_amenities>\n";
    $retVal .= "<safety_options><![CDATA[" . $this->safety_options . "]]></safety_options>\n";
    $retVal .= "<w_basic><![CDATA[" . $this->w_basic . "]]></w_basic>\n";
    $retVal .= "<w_drivetrain><![CDATA[" . $this->w_drivetrain . "]]></w_drivetrain>\n";
    $retVal .= "<w_corrosion><![CDATA[" . $this->w_corrosion . "]]></w_corrosion>\n";
    $retVal .= "<w_roadside_ass><![CDATA[" . $this->w_roadside_ass . "]]></w_roadside_ass>\n";
//    $retVal .= "<broker><![CDATA[" . $this->broker . "]]></broker>\n";
    $retVal .= "<image_link><![CDATA[" . $this->image_link . "]]></image_link>\n";
    $retVal .= "<hits>" . $this->hits . "</hits>\n";
    $retVal .= "<date>" . $this->date . "</date>\n";
    $retVal .= "<published>" . $this->published . "</published>\n";
    
    if($all){

      $exclusion = "";
      $retVal .= "<rents>\n";
        $rents = $this->getAllRents($exclusion);
        foreach ($rents as $rent){
          $retVal .= $rent->toXML2(); 
        }
      $retVal .= "</rents>\n";

      $retVal .= "<rentrequests>\n";
        $rentrequests = $this->getAllRentRequests($exclusion);
        foreach ($rentrequests as $rentrequest){
          $retVal .= $rentrequest->toXML2(); 
        }
      $retVal .= "</rentrequests>\n";
    
      $retVal .= "<buyingrequests>\n";
        $buyingrequests = $this->getAllBuyingRequests($exclusion);
        foreach ($buyingrequests as $buyingrequest){
          $retVal .= $buyingrequest->toXML2(); 
        }
      $retVal .= "</buyingrequests>\n";

      $retVal .= "<reviews>\n";
        $reviews = $this->getReviews($exclusion);
        foreach ($reviews as $review){
          $retVal .= $review->toXML2(); 
        }
      $retVal .= "</reviews>\n";

      $retVal .= "<images>\n";
      $images_data = $this->getAllImages();
      foreach($images_data as $image_data){
        $retVal .= "<image>\n";
          $retVal .= "<thumbnail_img><![CDATA[" . $image_data->thumbnail_img . "]]></thumbnail_img>\n";
          $retVal .= "<main_img><![CDATA[" . $image_data->main_img . "]]></main_img>\n";
        $retVal .= "</image>\n";
      }
      $retVal .= "</images>\n";

      
    }
    $retVal .= "</vehicle>\n";

    return $retVal;
	}

}
?>
